! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#
! #|  Compute vector between two Cartesian points                            |#
! #+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#+#

#include "../include/assert.fh"
#include "../include/dprec.fh"

   subroutine unitv ( a, b, c, rab, rab_inv ) 

   implicit none

   _REAL_ , intent(in ) :: a(3), b(3) 
   _REAL_ , intent(out) :: c(3), rab, rab_inv  

   !  ..........................................................................

   intrinsic :: sqrt, dot_product 


!  +---------------------------------------------------------------------------+
!  |  C = ( B - A ) / | B - A |                                                |
!  +---------------------------------------------------------------------------+

   c(:) = b(:) - a(:) 

   rab = sqrt( dot_product( c, c ) ) 

   rab_inv = 1.0d0 / rab 

   c(:) = c(:) * rab_inv 

!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x
!  x+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++x

   end subroutine unitv
